-- File: Events.lua
-- What's for: We use this file for the event detections.

local SayKarmaEvent = CreateFrame("Frame");
SayKarmaEvent.playername = UnitName("player");
SayKarmaEvent:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");

-- ==================================================
--					EVENT
-- ==================================================
SayKarmaEvent:SetScript("OnEvent", function(_,_,_,event, _,_,sourceName, _,_,_,destName, _,_,spellId)
        -- is SayKarma enable ? just a fast way to disable SayKarma without to reload everything
        -- yes: we check the events
        -- no: we do nothing
        if (SayKarmaPrefs['SayKarmaEnable'] == "yes") then
            
            -- DeathKnight =====================================================
            if (SayKarmaPrefs['DeathKnightEnable'] == "yes") then           -- do we have to watch spells from DK ?
                -- Asphyxiate
                if ((spellId == 108194)
                    and (SayKarmaPrefs['DeathKnightAsphyxiate'] == "yes")   -- do we have to do an announce for this spell ?
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID    = spellId;                        -- ID
                    local splink  = GetSpellLink(spID);             -- get an link
                    local fromWho = (sourceName or "(unknown)");    -- who did that ?!
                    
                    -- SayKarmaAnnounce(whatHappened, whichClass, fromWho, whichSpell);
                    SayKarmaAnnounce("Stunned", "dk", fromWho, splink);
                    -- SendChatMessage("{rt8} Stunned by this dk "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
                -- Mind Freeze
                if ((spellId == 47528)                                      -- wowhead.com ID spell
                    and (SayKarmaPrefs['DeathKnightMindFreeze'] == "yes")   -- isEnable ?
                    and (destName == SayKarmaEvent.playername)              -- Am I the victim of this spell ?
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))   -- Applied or Refreshed or Interrupted
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);                     -- get an overmouse link of this spell
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "dk", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this dk -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");  -- display a message in /s
                    return;
                end

                -- Strangulate
                if ((spellId == 47476)
                    and (SayKarmaPrefs['DeathKnightStrangulate'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Stunned", "dk", fromWho, splink);
                    --SendChatMessage("{rt8} Stunned by this dk "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End DeathKnight =================================================

            -- Druid ===========================================================
            if (SayKarmaPrefs['DruidEnable'] == "yes") then
                -- Cyclone
                if ((spellId == 33786)
                    and (SayKarmaPrefs['DruidCyclone'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "druid", fromWho, splink);
                    --SendChatMessage("{rt8} " .. splink .. " on me, by this druid -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- FaeSilence
                if ((spellId == 114238)
                    and (SayKarmaPrefs['DruidFaeSilence'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "druid", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this druid -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
                -- Rake
                if ((spellId == 163505)
                    and (SayKarmaPrefs['DruidRake'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Stunned", "druid", fromWho, splink);
                    --SendChatMessage("{rt8} Stunned by this druid -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
                -- Skull Bash
                if ((spellId == 106839)
                    and (SayKarmaPrefs['DruidSkullBash'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "druid", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this druid -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
            end
            -- End Druid =======================================================

            -- Hunter ==========================================================
            if (SayKarmaPrefs['HunterEnable'] == "yes") then
                -- Counter Shot
                if ((spellId == 147362)
                    and (SayKarmaPrefs['HunterCounterShot'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "hunt", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this hunt -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Freezing Trap
                if ((spellId == 3355)
                    and (SayKarmaPrefs['HunterFreezingTrap'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "hunt", fromWho, splink);
                    --SendChatMessage("{rt8} ".. splink .." on me, by this hunt -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Silencing Shot
                if ((spellId == 41084)
                    and (SayKarmaPrefs['HunterSilencingShot'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "hunt", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this hunt -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
                -- Wyvern Sting
                if ((spellId == 19386)
                    and (SayKarmaPrefs['HunterWyvernSting'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Stunned", "hunt", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this hunt -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
            end
            -- End Hunter ======================================================

            -- Mage ============================================================
            if (SayKarmaPrefs['MageEnable'] == "yes") then
                -- Counterspell
                if ((spellId == 2139)
                    and (SayKarmaPrefs['MageCounterspell'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "mage", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this mage -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
                -- Deep Freeze
                if ((spellId == 44572)
                    and (SayKarmaPrefs['MageDeepFreeze'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Stunned", "mage", fromWho, splink);
                    --SendChatMessage("{rt8} Stunned by this mage "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
                -- Dragon's Breath
                if ((spellId == 31661)
                    and (SayKarmaPrefs['MageDragonsBreath'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Disoriented", "mage", fromWho, splink);
                    --SendChatMessage("{rt8} Stunned by this mage "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
               -- Frostjaw
                if ((spellId == 102051)
                    and (SayKarmaPrefs['MageFrostjaw'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "mage", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this mage -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Black Cat
                if ((spellId == 61305)
                    and (SayKarmaPrefs['MagePolymorphBlackCat'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "mage", fromWho, splink);
                    --SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Monkey
                if ((spellId == 161354)
                    and (SayKarmaPrefs['MagePolymorphMonkey'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "mage", fromWho, splink);
                    --SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Peacock
                if ((spellId == 161372)
                    and (SayKarmaPrefs['MagePolymorphPeacock'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "mage", fromWho, splink);
                    --SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Penguin
                if ((spellId == 161355)
                    and (SayKarmaPrefs['MagePolymorphPenguin'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "mage", fromWho, splink);
                    --SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Polar Bear Cub
                if ((spellId == 161353)
                    and (SayKarmaPrefs['MagePolymorphPolarBearCub'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "mage", fromWho, splink);
                    --SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Pig
                if ((spellId == 28272)
                    and (SayKarmaPrefs['MagePolymorphPig'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "mage", fromWho, splink);
                    --SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Rabbit
                if ((spellId == 61721)
                    and (SayKarmaPrefs['MagePolymorphRabbit'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "mage", fromWho, splink);
                    --SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end

                -- Polymorph - Sheep
                if ((spellId == 118)
                    and (SayKarmaPrefs['MagePolymorphSheep'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "mage", fromWho, splink);
                    --SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Turkey
                if ((spellId == 61780)
                    and (SayKarmaPrefs['MagePolymorphTurkey'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "mage", fromWho, splink);
                    --SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
                
                -- Polymorph - Turtle
                if ((spellId == 28271)
                    and (SayKarmaPrefs['MagePolymorphTurtle'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "mage", fromWho, splink);
                    --SendChatMessage("{rt8} ".. splink .." on me, by this mage -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Mage ========================================================

            -- Monk ============================================================
            if (SayKarmaPrefs['MonkEnable'] == "yes") then
                -- Leg Sweep
                if ((spellId == 119381)
                    and (SayKarmaPrefs['MonkLegSweep'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Stunned", "monk", fromWho, splink);
                    --SendChatMessage("{rt8} Stunned by this monk "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Paralysis
                if ((spellId == 115078)
                    and (SayKarmaPrefs['MonkParalysis'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Stunned", "monk", fromWho, splink);
                    --SendChatMessage("{rt8} Stunned by this monk "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Spear Hand Strike
                if ((spellId == 116705 or spellId == 173320)
                    and (SayKarmaPrefs['MonkSpearHandStrike'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "monk", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this monk -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Touch of Karma
                if ((spellId == 122470)
                    and (SayKarmaPrefs['MonkTouchOfKarma'] == "yes")
                    and (destName == SayKarmaEvent.playername and sourceName ~= destName)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounceTouched(fromWho, splink);
                    --SendChatMessage("{rt8} " .. splink .. " on me (10s). Stop dps this monk -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Monk ========================================================

            -- Paladin =========================================================
            if (SayKarmaPrefs['PaladinEnable'] == "yes") then
                -- Fist of Justice
                if ((spellId == 105593)
                    and (SayKarmaPrefs['PaladinFistOfJustice'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Stunned", "paladin", fromWho, splink);
                    --SendChatMessage("{rt8} Stunned by this paladin "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Hammer of Justice
                if ((spellId == 853)
                    and (SayKarmaPrefs['PaladinHammerOfJustice'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Stunned", "paladin", fromWho, splink);
                    --SendChatMessage("{rt8} Stunned by this paladin "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Rebuke
                if ((spellId == 96231)
                    and (SayKarmaPrefs['PaladinRebuke'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "paladin", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this paladin -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Repentance
                if ((spellId == 20066)
                    and (SayKarmaPrefs['PaladinRepentance'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "paladin", fromWho, splink);
                    --SendChatMessage("{rt8} Stunned by this paladin -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Paladin =====================================================

            -- Priest ==========================================================
            if (SayKarmaPrefs['PriestEnable'] == "yes") then
                -- Dominate Mind
                if ((spellId == 605)
                    and (SayKarmaPrefs['PriestDominateMind'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "priest", fromWho, splink);
                    --SendChatMessage("{rt8} ".. splink .." on me, cc this priest -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end

                -- Holy Word: Chastise
                if ((spellId == 88625)
                    and (SayKarmaPrefs['PriestHolyWordChastise'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Stunned", "priest", fromWho, splink);
                    --SendChatMessage("{rt8} Stunned by this priest -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Psychic Horror
                if ((spellId == 64044)
                    and (SayKarmaPrefs['PriestPsychicHorror'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Feared", "priest", fromWho, splink);
                    --SendChatMessage("{rt8} Feared by this priest -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Silence
                if ((spellId == 15487)
                    and (SayKarmaPrefs['PriestSilence'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "priest", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this priest -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

            end
            -- End Priest ======================================================

            -- Rogue ===========================================================
            if (SayKarmaPrefs['RogueEnable'] == "yes") then
                -- Blind
                if ((spellId == 2094)
                    and (SayKarmaPrefs['RogueBlind'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "rogue", fromWho, splink);
                    --SendChatMessage("{rt8} " .. splink .. " on me, by this rogue -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end

                -- Garrote
                if ((spellId == 1330 or spellId == 703)
                    and (SayKarmaPrefs['RogueGarrote'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "rogue", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this rogue -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- kick
                if ((spellId == 1766)
                    and (SayKarmaPrefs['Roguekick'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "rogue", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this rogue -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Sap
                if ((spellId == 6770)
                    and (SayKarmaPrefs['RogueSap'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Sapped", "rogue", fromWho, splink);
                    --SendChatMessage("{rt8} Sapped, by this rogue -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Rogue =======================================================

            -- Shaman ==========================================================
            if (SayKarmaPrefs['ShamanEnable'] == "yes") then
                -- Hex
                if ((spellId == 51514)
                    and (SayKarmaPrefs['ShamanHex'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(3, "shaman", fromWho, splink);
                    --SendChatMessage("{rt8} ".. splink .." on me, by this shaman -> "..(sourceName or "(unknown)") .." ! {rt8}","SAY");
                    return;
                end

                -- Wind Shear
                if ((spellId == 57994)
                    and (SayKarmaPrefs['ShamanWindShear'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "shaman", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this shaman -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Shaman ======================================================

            -- Warlock =========================================================
            if (SayKarmaPrefs['WarlockEnable'] == "yes") then
                -- Mesmerize
                if ((spellId == 115268)
                    and (SayKarmaPrefs['WarlockMesmerize'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SendChatMessage("{rt8} Seduced, cc that succube asap ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Seduction
                if ((spellId == 6358)
                    and (SayKarmaPrefs['WarlockSeduction'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce(4, "warlock", fromWho, splink);
                    SendChatMessage("{rt8} Seduced, cc that succube asap ".. splink .." ! {rt8}","SAY");
                    return;
                end
                
                -- Spell Lock
                if ((spellId == 19647)
                    and (SayKarmaPrefs['WarlockSpellLock'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "warlock", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this warlock -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Warlock =====================================================

            -- Warrior =========================================================
            if (SayKarmaPrefs['WarriorEnable'] == "yes") then
                -- Dragon Roar
                if ((spellId == 118000)
                    and (SayKarmaPrefs['WarriorDragonRoar'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "war", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this war -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Pummel
                if ((spellId == 6552)
                    and (SayKarmaPrefs['WarriorPummel'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Silenced", "war", fromWho, splink);
                    --SendChatMessage("{rt8} Silenced by this war -> "..(sourceName or "(unknown)") .." with: ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Shockwave
                if ((spellId == 132168) -- or ((spellId == 46968)
                    and (SayKarmaPrefs['WarriorShockwave'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Stunned", "war", fromWho, splink);
                    --SendChatMessage("{rt8} Stunned by this war "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end

                -- Storm Bolt
                if ((spellId == 107570 or spellId == 145585)
                    and (SayKarmaPrefs['WarriorStormBolt'] == "yes")
                    and (destName == SayKarmaEvent.playername)
                    and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_INTERRUPT"))
                then
                    local spID = spellId;
                    local splink = GetSpellLink(spID);
                    local fromWho = (sourceName or "(unknown)");
                    
                    SayKarmaAnnounce("Stunned", "war", fromWho, splink);
                    --SendChatMessage("{rt8} Stunned by this war "..(sourceName or "(unknown)") .." with -> ".. splink .." ! {rt8}","SAY");
                    return;
                end
            end
            -- End Warrior =====================================================

        end -- if (SayKarmaPrefs['SayKarmaEnable'] == "yes") then
    end -- function(_,_,_,event, _,_,sourceName, _,_,_,destName, _,_,spellId)
); -- SayKarmaEvent:SetScript(
